'use strict';

var Replacer = require('regexp-sourcemaps');
var through = require('through2');
var applySourceMap = require('vinyl-sourcemaps-apply');

module.exports = function(regexp, replace, name) {
  var replacer = new Replacer(regexp, replace, name);
  return through.obj(function(file, enc, cb) {
    var result = replacer.replace(file.contents.toString('utf8'), file.relative);
    file.contents = new Buffer(result.code);

    if (file.sourceMap)
      applySourceMap(file, result.map);

    cb(null, file);
  });
};
